# -*- coding: utf-8 -*-
from setuphelpers import *
import os

# Declaring specific app values (TO CHANGE)
bin_name_string = "putty-64bit-%s-installer.msi"


def update_package():
    print("Downloading/Updating package content from upstream binary sources")

    # Initializing variables
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name
    app_arch = control.architecture
    url = control.sources
    bin_start = bin_name_string.split("%s")[0]
    # Translation arch
    if app_arch == "x64":
        url_dl_part = "https://the.earth.li/~sgtatham/putty/latest/w64/"
    else:
        url_dl_part = "https://the.earth.li/~sgtatham/putty/latest/w32/"

    # Getting latest version from official website
    print("URL used is: " + url)
    for read_bs in bs_find_all(url, "code", proxies=proxies):
        if read_bs.text.startswith(bin_start):
            latest_bin = read_bs.text
            version = latest_bin.split("-")[-2]
            break
    url_dl = url_dl_part + latest_bin

    print("Latest %s version is: %s" % (app_name, version))
    print("Download url is: %s" % url_dl)

    # Downloading latest binaries
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(url_dl, latest_bin, proxies=proxies)

        # Checking version from file
        version_from_file = get_msi_properties(latest_bin)["ProductName"].split(" ")[2]
        if version != version_from_file:
            os.rename(latest_bin, bin_name_string % version_from_file)
            version = version_from_file

        # Changing version of the package
        control.version = "%s-%s" % (version, int(control.version.split("-")[-1]) + 1)
        control.save_control_to_wapt()
        print("Changing version to: %s in WAPT\\control" % control.version)

    # Deleting outdated binaries
    remove_outdated_binaries(version)
